<?


function chart ($data, $width, $height, $max_value, $color_r, $color_g, $color_b, $div=1, $date) {

	$step = $width / (sizeof($data)-1);

	$scale = $max_value / $height;


	# create the image
	$h_offset = 18;
	$v_offset = 10;
	$img = ImageCreate ($width, $height);
	$img2 = ImageCreate ($width + ($h_offset * 2), $height + ($v_offset * 2));



	# define colors
	$bgcolor = ImageColorAllocate ($img2, 245, 245, 245);
	$white = ImageColorAllocate ($img, 255, 255, 255);
	$black = ImageColorAllocate ($img, 0, 0, 0);
	$gray = ImageColorAllocate ($img, 200, 200, 200);
	$color = ImageColorAllocate ($img, $color_r, $color_g, $color_b); 

	ImageFill ($img2, 0,0, $bgcolor);


	# cycle thru data
	for ($counter = 1; $counter <= sizeof($data)-1; $counter ++) {

		# coords
		$x = $counter * $step;
		$y = ($data[$counter] / $scale) / $div;
		$prev_y = ($data[$counter-1] / $scale) / $div;


		# vertical rule
		$divider = sizeof($data) / 10;
		if ($counter % $divider == 0) {
			$timestring = strftime ("%H:%M", $date[$counter]);
			if ($timestring == "00:00") {
				$timestring = strftime ("%D", $date[$counter]);
			}	
			ImageStringUp ($img, 1, $x-3, 28, $timestring, $black);
			ImageLine ($img, $x, 0, $x, 3, $black);
		}


		# line
		ImageLine ($img, $x-$step, $height - $prev_y, $x, $height-$y, $color);	
	}



	# border lines
	ImageLine ($img, 0, 0, sizeof($data) * $step, 0, $black);
	ImageLine ($img, 0, $height-1, sizeof($data) * $step, $height-1, $black);


	ImageCopy ($img2, $img, $h_offset, $v_offset, 0, 0, $width, $height);
	ImageDestroy ($img);

	ImageString ($img2, 1, 0, 0, "kb/s", $black);

	$bandwidth_string = $max_value * 8 / 1024 / 60;
	$yoff = 10;
	$n = 4;
	while($n > 0) {
		ImageString ($img2, 1, 0, $yoff, $bandwidth_string, $black);
		$bandwidth_string /= 2;
		$yoff += ($height / 4);
		$n--;
	}

	# send the image 
	header("content-type: image/png");
	ImagePng($img2);
	ImageDestroy ($img2);


}

?>
